/* conf.h
 *
 * Modified from the Internet Gopher program, copyright (C) 1991
 * University of Minnesota Microcomputer Workstation and Networks Center
 *
 */

/*
 * You may hard-wire a specific machine here:
 */

//#define IS_A_HPUX
//#define IS_AUX_BOX
//#define IS_A_RS6000
//#define IS_NEXT
//#define IS_BSD
//#define IS_A_DEC
//#define IS_A_IRIS
//#define IS_A_SUN
//#define IS_A_APOLLO

     /*
      * These are implementation specific #defines
      */

#if !defined(IS_A_SUN) && defined(sun)
#define IS_A_SUN
#endif

#if !defined(IS_A_DEC) && defined(ultrix)
#define IS_A_DEC
#endif

#if !defined(IS_A_IRIS) && defined(sgi)
#define IS_A_IRIS
#endif

#if !defined(IS_NEXT) && defined(NeXT)
#define IS_A_NEXT
#endif

#if !defined(IS_A_HPUX) && defined(hpux)
#define IS_A_HPUX
#endif

#if !defined(IS_A_APOLLO) && defined(APOLLO)
#define IS_A_APOLLO
#endif

/*** All our mongo include files ***/

#include <stdio.h>

#ifndef IS_BSD
#include <stdlib.h>
#endif

#include <signal.h>

#ifdef __convex__
#define cbreak crmode
#endif

#ifndef __convex__
#include <string.h>
#endif

#include <ctype.h>
#include <errno.h>
#include <time.h>

#define HALFLINE 40
#define WHOLELINE 80

#define MAXSTR 200           /* Arbitrary maximum string length */
                             /* WEIRD BUG!!!! A value greater than
                200 doesn't work on Sparcs!  Why???? */


/** Get the configuration variables **/

/*
 * These are implementation specific #defines
 */

#ifdef IS_A_DEC
#define SYSVCURSES
#endif

#ifdef IS_A_SUN
#define SYSVCURSES
#endif

#ifdef IS_A_IRIS
#define SYSVCURSES
#endif

#ifdef IS_A_HPUX
#define SYSVCURSES
#endif

#ifdef IS_AUX_BOX
#define SYSVCURSES
#endif

#ifdef IS_A_RS6000
#define SYSVCURSES
#endif

#ifdef IS_BSD
#define tolower
#define NO_VPRINTF
#endif

#ifdef IS_NEXT
#define __STRICT_BSD__
#define NO_VPRINTF
#endif

#ifdef IS_A_APOLLO
#define NONODELAY
#endif

/* site specific defines: */

#define HYPERGBASE "/usr/local/Hyper-G"

/* SGMLBASE can be overridden by command line */
//#define SGMLBASE   "/usr/local/Hyper-G/sgml"
#define SGMLBASE   "/amadeus"

/* DTD, Style and Hyphenation files for the SGML parser: */
#define BASEFILE   "hyper-g"
#define STYLEFILE  "hyper-g.sty"
#define HYPHENBASE "hyf."

#define VTKEYS

#define EDITCOMMAND "hgedit"
#define HGVIEWERRC  ".hgviewer.rc"
#define MAILCOMMAND "/usr/ucb/mail"
#define GIFDISPLAYCOMMAND "xv -"
#define TIFFDISPLAYCOMMAND "xv -"
#define PICTDISPLAYCOMMAND "picttoppm | xv -"
#define SOUNDDISPLAYCOMMAND "play"
#define HTF2PSCOMMAND  "hgparse -s htf2roff.sty -w 132 -y | groff -mhg "
#define HTF2RTFCOMMAND "(cat /usr/local/Hyper-G/sgml/rtf.hdr; hgparse -b htf2rtf -s htf2rtf.sty -w 132 -y)"
#define TELNETCOMMAND "hgtelnet"
#define TELNETPORT "23"
#define DEFAULT_WWW_PORT "80"
#define DEFAULT_GOPHER_PORT "70"
#define DEFAULT_WAIS_PORT "210"

