// <copyright>
// 
// Copyright (c) 1994,1995
// Institute for Information Processing and Computer Supported New Media (IICM),
// Graz University of Technology, Austria.
// 
// </copyright>


//<file>
//
// Name:       LangImp.cpp
//
// Purpose:    
//
// Created:    15 Mar 1995   Gnter Nagler
//
// Modified:   17 Mar 1995   Thomas Dietinger
//
//
//</file>

#include <stdafx.h>
#include <apps/language.h>
#include <InterViews/boolean.h>

LangMsg help_comm(
  "en:Viewer Commands",
  "ge:Befehle des Viewers",
  "fr:Affichage des Commandes",
  "st:Befhle vun Viewa");

boolean invalid[NUMCOMMANDS];

LangMsg commands[NUMCOMMANDS] = {
/*  0 */ LangMsg("en:help",	"ge:hilfe",	"fr:aide", "st:hf ma!"),
/*  1 */ LangMsg("??:quit",	"fr:quitter", "st:gibs auf"),
/*  2 */ LangMsg("en:exit", "ge:ende", "fr:sortir",	"st:mch schlu"),
/*  3 */ LangMsg("en:language english","ge:sprache englisch","fr:langue anglaise","st:red' englisch"),
/*  4 */ LangMsg("en:language german","ge:sprache deutsch", "fr:langue allemande","st:red' deitsch"),
/*  5 */ LangMsg("en:language french","ge:sprache franzsisch", "fr:langue francais","st:red' franzsisch"),
/*  6 */ LangMsg("en:language styrian","ge:sprache steirisch", "fr:langue styrienne","st:red' stoasteirisch"),
/*  7 */ LangMsg("??:info"),
/*  8 */ LangMsg("??:links","fr:liens","st:zag de links"),
/*  9 */ LangMsg("en:references","ge:referenzen","fr:rfrences","st:wea linkt d her"),
/* 10 */ LangMsg("en:browse","ge:zeige","fr:passer en revue","st:heazagn"),
/* 11 */ LangMsg("en:output +","ge:ausgeben +","fr:sortie +","st:gibs aus +"),
/* 12 */ LangMsg("en:search on attributes","ge:suche objekt","fr:trouver un objet","st:suach ma gschwind ws aui"),
/* 13 */ LangMsg("en:find similar","ge:suche weitere","fr:trouver un semblable","st:suach ma no sows"),
/* 14 */ LangMsg("en:search titles","ge:suche schlsselwort","fr:recherche sur un mot","st:suach ma noch an wurt"),
/* 15 */ LangMsg("en:search full text","ge:suche volltext","fr:recherche sur tout le texte","st:suach in ganzn text"),
/* 16 */ LangMsg("en:children", "ge:kinder","fr:enfants","st:gschrappn"),
/* 17 */ LangMsg("en:parents","ge:eltern","fr:parents","st:ahnderln"),
/* 18 */ LangMsg("en:home", "ge:heim","fr:maison","st:ham"),
/* 19 */ LangMsg("en:history","ge:geschichte","fr:histoire","st:wos wor"),
/* 20 */ LangMsg("en:undo", "ge:zurck","fr:annuler","st:geh' z'ruck"),
/* 21 */ LangMsg("en:redo", "ge:wiederholen","fr:restaurer","st:geh' firi"),
/* 22 */ LangMsg("en:continue","ge:weitermachen","fr:continuer","st:tua weida"),
/* 23 */ LangMsg("en:identify","ge:identifizieren","fr:identification","st:wea bin i"),
/* 24 */ LangMsg("en:insert document","ge:neues dokument","fr:insrer un document","st:neichs dokument"),
/* 25 */ LangMsg("en:erase object","ge:entferne objekt","fr:effacer l'objet","st:schmei weg des g'lump"),
/* 26 */ LangMsg("en:move to coll.","ge:verschiebe zu coll.","fr:transfrer vers coll.","st:gibs zum"),
/* 27 */ LangMsg("en:copy to coll.","ge:kopiere nach coll.","fr:copier dans coll.","st:kopiers"),
/* 28 */ LangMsg("en:unlink from coll.","ge:entferne von coll.","fr:annuler le lien de la coll.","st:tuas weg vun"),
/* 29 */ LangMsg("en:create duplicate","ge:erzeuge duplikat","fr:crer un double","st:moch a neiche kopie"),
/* 30 */ LangMsg("en:mail native","ge:mail original","fr:courrier original","st:schick's original"),
/* 31 */ LangMsg("en:mail ascii","ge:mail ascii","fr:courrier ascii","st:schick' ascii"),
/* 32 */ LangMsg("en:mail postscript","ge:mail postscript","fr:courrier postscript","st:schick' postscript"),
/* 33 */ LangMsg("en:mail rtf", "ge:mail rtf","fr:courrier rtf","st:schick' rtf"),
/* 34 */ LangMsg("en:option sort","ge:option sortieren","fr:option tri","st:optschn suatiarn"),
/* 35 */ LangMsg("en:option full text","ge:option volltext","fr:option texte entier","st:optschn fuitext"),
/* 36 */ LangMsg("en:activate","ge:aktiviere","fr:activer","st:moch oktiv"),
/* 37 */ LangMsg("en:deactivate","ge:deaktiviere","fr:dsactiver","st:moch inoktiv"),
/* 38 */ LangMsg("en:show active colls","ge:zeige aktive coll.","fr:montrer coll. active(s)","st:zag oktive kollektschn"),
/* 39 */ LangMsg("??:status","st:wos is heit los"),
/* 40 */ LangMsg("en:edit text", "ge:editiere text","fr:dition du texte","st:tua ws mit'n text"),
/* 41 */ LangMsg("en:new text","ge:neuer text","fr:nouveau texte","st:moch an neichn text"),
/* 42 */ LangMsg("en:annotate","ge:neuer kommentar","fr:commenter","st:moch an kommentar"),
/* 43 */ LangMsg("en:make link","ge:verbinde","fr:tablir un lien","st:moch an link"),
/* 44 */ LangMsg("en:update screen","ge:bildschirm neuaufbau","fr:mettre  jour l'cran","st:mol's no amol hin"),
/* 45 */ LangMsg("en:modify attributes","ge:attribute ndern","fr:modifier les attributs","st:enda attribute"),
/* 46 */ LangMsg("en:add attributes","ge:attribute hinzufgen","fr:ajouter des attributs","st:neichs attribut"),
/* 47 */ LangMsg("en:change password","ge:passwort ndern","fr:changer mot de passe","st:enda posswurt"),
/* 48 */ LangMsg("en:goto collection","ge:gehe zur collection","fr:aller  la collection","st:geh' zua kollektschn"),
/* 49 */ LangMsg("en:show annotations","ge:zeige kommentare","fr:show annotations@","st:zag kommentare"),

/* 50 */ LangMsg(),     // not really a command

/* 51 */ LangMsg("en:insert collection","ge:neue collection","fr:insrer un collection","st:neiche kollektschn"),
/* 52 */ LangMsg("en:insert cluster","ge:neuer cluster","fr:insrer un cluster","st:neicha cluster"),
/* 53 */ LangMsg("en:insert image","ge:neues Bild","fr:insrer un image","st:neichs bld"),
/* 54 */ LangMsg("en:insert movie","ge:neuer Film","fr:insrer un film","st:neicha flm"),
/* 55 */ LangMsg("en:insert sound","ge:neues tondokument","fr:insrer un document du ton","st:neichs tondokument"),
/* 56 */ LangMsg("en:insert scene","ge:neue 3D-szene","fr:insrer une scne","st:neiche 3D szene "),
/* 57 */ LangMsg("en:insert postscript document","ge:neues PostScript Dokument","fr:insrer un document du PostScript",
					"st:neichs poschtschkriptdokument"),
/* 58 */ LangMsg("en:insert remote connection","ge:neue remote Verbindung","fr:insrer une connection",
      				"st:neiche vabindung"),
/* 59 */ LangMsg("en:insert generic","ge:neues benutzerdokument","fr:insrer un document ???","st:neichs benuzadokument"),
/* 60 */ LangMsg("en:send message","ge:Nachricht versenden","fr:send message","st:Nochricht vaschickn"),
/* 61 */ LangMsg("en:make link","ge:neuer Link","fr:make link","st:moch an link"),
/* 62 */ LangMsg("??:inline"),
};

LangMsg Copyrightstr("en:Amadeus (P%d/C%d),  1991-95 Graz Univ. of Technology",
                     "ge:Amadeus (P%d/C%d),  1991-95 TU Graz",
                     "fr:Amadeus (P%d/C%d),  1991-95 Univ. de la Technologie, Graz",
                     "st:Amadeus (P%d/C%d),  1991-95 TU Graz",
                     "sp:Amadeus (P%d/C%d),  1991-95 Graz Univ. of Technology",
                     "it:Amadeus (P%d/C%d),  1991-95 Graz Univ. of Technology");
LangMsg Commandstr("en:Command (?:help): ",
                     "ge:Befehl (?:Hilfe): ",
                     "fr:Commande (?:aide): ",
                     "st:Ws wst'n (druck '?' fia Hfe): ");
LangMsg Pagestr(   "en: Page %d of %d ",
                     "ge: Seite %d von %d ",
                     "fr: Page %d de %d ",
                     "st: Seitn %d vun %d ");
LangMsg Movestr(   "en:Move To Line: ",
                     "ge:Gehe zu Zeile: ",
                     "fr:Aller  la ligne:",
                     "st:Geh zur Zaln (oba gschwind!): ");
LangMsg MvPgstr(   "en:Move To Page: ",
                     "ge:Gehe zu Seite: ",
                     "fr:Aller  la page:",
                     "st:Geh zur Seit'n (oba gschwind!): ");
LangMsg Followstr( "en:Follow Link: ",
                     "ge:Folge Link: ",
                     "fr:Suivre le lien: ",
                     "st:Fulg'n Link: ");
LangMsg Keywordstr("en:Search for Keyword: ",
                     "ge:Suche nach Schlsselwort: ",
                     "fr:Recherche par mots cls: ",
                     "st:Suach noch den Wurt: ");
LangMsg Fulltextstr("en:Full text search: ",
                     "ge:Volltext-Suche nach: ",
                     "fr:Recherche sur tout le texte:",
                     "st:Suach in ganzn Text: ");
LangMsg ISearchstr("en:I-Search: ",
                     "ge:I-Suche: ",
                     "fr:I-Recherche",
                     "st:Suach schn: ");
LangMsg UserIDstr( "en:Username: ",
                     "ge:Benutzername: ",
                     "fr:Utilisateur:",
                     "st:Wia hat: ");
LangMsg Passwordstr("en:Password: ",
                     "ge:Pawort: ",
                     "fr:Mot de passe:",
                     "st:G'heims Wurt: ");
LangMsg OldPassstr("en:Old password: ",
                     "ge:Altes Pawort: ",
                     "fr:$Old password: ",
                     "st:Oits g'heims Wurt: ");
LangMsg NewPassstr("en:New password: ",
                     "ge:Neues Pawort: ",
                     "fr:$New password: ",
                     "st:Neichs g'heims Wurt: ");
LangMsg Againstr(  "en:One more time, please: ",
                     "ge:Nocheinmal bitte: ",
                 "fr:$One more time, please: ",
                     "st:Amol no bittschen: ");
LangMsg Gotostr(   "en:Go to [collectionname]: ",
                     "ge:Gehe zu [Collection-Name]: ",
                     "fr:$Go to [collectionname]: ",
                     "st:Geh noch: ");
LangMsg Outputstr( "en:Pipe to: ",
                     "ge:Ausgabe-Befehl: ",
                     "fr:Diriger vers:",
                     "st:Ausgobe-Befhl: ");
LangMsg Mailstr(   "en:Mail to: ",
                     "ge:Sende an: ",
                     "st:Schick's aun: ",
                     "fr:Envoyer : ");
LangMsg Savestr(   "en:Save as: ",
                     "ge:Speichern unter: ",
                     "fr:Enregistrer sous: ",
                     "st:Merkn unta: ");
LangMsg Authorstr( "en:Author (default all): ",
                     "ge:Autor (alle): ",
                     "fr:Auteur (tous par dfaut): ",
                     "st:Vun wen is des Ding: ");
LangMsg Datestr(   "en:Created after (yy/mm/dd): ",
                     "ge:Ab Datum (jj/mm/tt): ",
                     "fr:Cr aprs (aa/mm/jj): ",
                     "st:Seit wounn: ");
LangMsg SortOrdstr("en:Sort Order [-][#AEOCPSTt]*: ",
                     "ge:Sortier-Reihenfolge [-][#AEOCPSTt]*: ",
                     "fr:Ordre pour le tri  [-][#AEOCPSTt]*:",
                     "st:Wia sull I suatiarn [-][#AEOCPSTt]*: ");
LangMsg OptFtextstr("en:Number of full text matches: ",
                     "ge:Anzahl der Volltext-Gefundenen: ",
                     "fr:Nombre de reponses dans tout le texte: ",
                     "st:Wia fle fuitext-dinga: ");
LangMsg Resultstr( "en:Found %d item(s)",
                     "ge:%d Eintrge gefunden",
                     "fr:%d sujet(s) trouv(s)",
                     "st:D hb i %d Sochn g'fundn");
LangMsg Completestr("en:Possible Completions:",
                     "ge:Gltige Kommandos",
                     "fr:Sorties alternatives",
                     "st:D gibs hiazn");
LangMsg Historystr("en:Latest Commands ('*' = Undone)",
                     "ge:Die letzten Kommandos ('*' = zurckgenommen)",
                     "fr:Dernires commandes excutes ('*' = annulle)",
                     "st:Des worn d'letztn Befhle");
LangMsg Activestr( "en:Active Collections",
                     "ge:Aktive Collections",
                     "fr:Collections Actives",
                     "st:Des san de oktivn Kollektschs");
LangMsg Childrenstr("en:Collection \"%s\" has %d Children",
                     "ge:Zu \"%s\" gehren %d Eintrge",
                     "fr:Collection \"%s\" a %d enfants",
                     "st:Zua \"%s\" ghearn %d Sochn");
LangMsg Parentsstr("en:Parent Collection(s) of \"%s\"",
                     "ge:\"%s\" gehrt zu",
                     "fr:Parents de la(les) Collection(s) \"%s\"",
                     "st:\"%s\" gheart zua");
LangMsg Similarstr("en:Documents similar to \"%s\"",
                     "ge:Dokumente hnlich wie \"%s\"",
                     "fr:Documents semblables  \"%s\"",
                     "st:Sochn sou wia \"%s\"");
LangMsg Modifystr( "en:Modify which attribute?",
                     "ge:Welches Attribute soll modifiziert werden?",
                     "fr:Modifier quel attribut?",
                     "st:Ws wst'n endan?");
LangMsg Addattrstr("en:Add which attribute?",
                     "ge:Welches Attribute soll hinzugefgt werden?",
                     "fr:Quel attribut ajouter?",
                     "st:Ws wst'n dozuatuan?");
LangMsg Connectstr("en:Connecting to %s (port %d)",
                     "ge:Verbindungsaufbau mit %s (Port %d)",
                     "fr:Connexion  %s (port %d) en cours",
                     "st:I red mit'n %s (Port %d)");
LangMsg Textstr(   "en:receiving text",
                     "ge:empfange Text",
                     "fr:Rception du texte en cours",
                     "st:I hul'n Text");
LangMsg Bytesstr(  "en:%d bytes received",
                     "ge:%d Bytes empfangen",
                     "fr:%d bytes reus",
                     "st:hob scho %d Bytes do");
LangMsg CheckLinkstr( "en:checking links...",
                     "ge:berprfe Links...",
                     "fr:checking links...",
                     "st:I schau no gschwind de links duach...");
LangMsg Formatstr( "en:formatting...",
                     "ge:formatiere Text",
                     "fr:Formatage en cours",
                     "st:I mol'n Text");
LangMsg Sortstr(   "en:sorting...",
                     "ge:sortiere Liste",
                     "fr:Tri en cours",
                     "st:I surtier grad");
LangMsg Linkstr(   "en:'%s' has links to",
                     "ge:'%s' verweist auf",
                     "fr:'%s' a un lien avec",
                     "st:'%s' zagt auf");
LangMsg Refstr(    "en:%d items reference '%s'",
                     "ge:%d Objekte referenzieren '%s'",
                     "fr:%d objets ont des liens avec '%s'",
                     "st:%d Dinga zagn auf '%s'");
LangMsg ShowAnnostr(  "en:There are %d annotation(s) to '%s'",
                     "ge:Es gibt %d Kommentar(e) zu '%s'",
                     "fr:There are %d annotation(s) to '%s' @",
                     "st:%d Dinga kommentiern '%s'");
LangMsg Returnstr( "en: Press <RETURN> ",
                     "ge: <EINGABE> drcken ",
                     "fr: Taper <RETOUR>",
                     "st: druck <EINGABE>, Depp!");
LangMsg Abortstr(  "en:ESC=Abort",
                     "ge:ESC=Abbruch",
                     "fr:ESC=Interrompre",
                     "st:ESC=Gib's auf");
LangMsg Waitstr(   "en:Wait a moment, please",
                     "ge:Bitte warten",
                     "fr:Attendez, s'il vous plat",
                     "st:wart's ab!");
LangMsg Quitstr(   "en:Really want to quit? [y] ",
                     "ge:Wirklich beenden? [j] ",
                     "fr:Session Termine - Confirmez? [o] ",
                     "st:Sull I's echt aufgeb'n? [j] ");
LangMsg Yesstr(    "en:yY",
                     "ge:jJ",
                     "fr:oO",
                     "st:jJ");
LangMsg Nostr(     "??:nN");
LangMsg Nofindstr( "en:*** found nothing or access denied ***",
                     "ge:*** Nichts gefunden oder Zugriff verweigert ***",
                     "fr:*** Introuvable ***",
                     "st:*** A so ws gibts net ***");
LangMsg Overflowstr( "en:*** Warning: Too many (intermediate) matches found ***",
                     "ge:*** Achtung: Zu viele (Zwischen-)Resultate gefunden ***",
                     "fr:*** Warning: Too many (intermediate) matches found ***",
                     "st:*** Pa auf: Z'vle g'fundn ***");
LangMsg Notimplstr("en:*** command not yet implemented ***",
                     "ge:*** Befehl noch nicht implementiert ***",
                     "fr:*** commande non encore disponible ***",
                     "st:*** Den Befh knn i no net (aba bld) ***");
LangMsg Invalidstr("en:*** invalid command ***",
                     "ge:*** Unbekannter Befehl ***",
                     "fr:*** commande inconnue ***",
                     "st:*** Den Befh gibts net ***");
LangMsg Noundostr( "en:*** No more UNDOs possible ***",
                     "ge:*** Geht nicht weiter zurck ***",
                     "fr:*** Rien  annuller ***",
                     "st:*** Geht net mea zruck ***");
LangMsg Noredostr( "en:*** Nothing more to REDO ***",
                     "ge:*** Nichts mehr zu Wiederholen ***",
                     "fr:*** Rien de plus  restaurer ***",
                     "st:*** Nix mea z'tuan ***");
LangMsg Existsstr( "en:*** Object already exists ***",
                     "ge:*** Objekt existiert bereits ***",
                     "fr:*** L'object existe dj ***",
                     "st:*** Ds Ding gibts scho ***");
LangMsg Changestr( "en:*** Database modified ***",
                     "ge:*** Datenbank modifiziert ***",
                     "fr:*** Base de donnes modifie ***",
                     "st:*** Datenbank modifiziert ***");
LangMsg NotIdentstr("en:*** Must identify first ***",
                     "ge:*** Zuerst identifizieren ***",
                     "fr:*** Identification pralable ***",
                     "st:*** Zerscht idifizian ***");
LangMsg Noactivestr("en:*** no active collection ***",
                     "ge:*** Keine Collection aktiv ***",
                     "fr:*** Aucune collection active ***",
                     "st:*** Ka aktive kollektschn ***");
LangMsg WrongPasswordstr("en:*** password wrong ***",
                     "ge:*** Pawort falsch ***",
                     "fr:*** $password wrong ***",
                     "st:*** G'heims Wurt foisch ***");
LangMsg CloseLinkLeftline(
                     "en:Go to destination for: ",
                     "ge:Gehe zum Ziel fr: ",
                     "fr:Aller  la destination pour: ",
                     "st:Geh noch: ");
LangMsg CloseLinkRightline(
                     "en:Then make link (^L)",
                     "ge:Dann verbinde mit ^L",
                     "fr:Faire ensuite le lien (^L)",
                     "st:Nocha moch zua mit ^L");
LangMsg Annostr(   "en: %d annotation(s) (^A) ",
                     "ge: %d Kommentar(e) (^A) ",
                     "fr: %d annotation(s) (^A)@ ",
                     "st: Do gibts %d Kommentar(e) (^A) ");
LangMsg MMwaitstr( "en: * Multimedia Document * ",
                     "ge: * Multimedia Dokument * ",
                     "fr: * Document multi-media * ",
                     "st: * Dokument mit Bdln * ");
LangMsg MMnoavailstr("en: * Sorry, no multimedia documents on your terminal * ",
                     "ge: * Leider keine Multimedia-Dokumente mglich * ",
                     "fr: * $Sorry, no multimedia documents on your terminal * ",
                     "st: * 's gibt kane Dokumente mit Bdln bei dia * ");
LangMsg DirStatusline(
"en:?:help, q:quit, RETURN:select, BACKSPACE:back, ARROWS:scroll",
"ge:?:Hilfe, q:Beenden, RETURN:Auswahl, BACKSPACE:Zurck, PFEILE:Scrollen",
"fr:?:Aide, q:quitter, RETURN: slection, BACKSPACE:retour, FLECHES:dfiler cran",
"st:?:Hfe, q:gibs auf, RETURN:zag her, BACKSPACE:zruck, PFEILE:aufi-obi");
LangMsg TextStatusline(
"en:?:help, q:quit, BACKSPACE:back, ARROWS:scroll, -/+:page up/down",
"ge:?:Hilfe, q:Beenden, BACKSPACE:Zurck, PFEILE:Scrollen, +/-:Blttern",
"fr:?:Aide, q:quitter, BACKSPACE:retour, FLECHES:dfiler cran, -/+:page sup/inf",
"st:?:Hfe, q:gibs auf, BACKSPACE:zruck, PFEILE:aufi-obi, +/-:blattln");

LangMsg ServerStatStr(
"en:<TITLE>Server Status<P><XMP>\
<HP1>Server:</HP1> %s\n\n\
<HP1>Server Time:</HP1> %s  <HP1>Up since:</HP1> %s (%d days, %02d:%02d:%02d)\n\n\
<HP1>Performance Index:</HP1> %6.2f (1')  %6.2f (15')  %6.2f (60')  %6.2f (boottime)\n\n\n\
<HP1>Online Users:</HP1>\n\n\
<HP3>  No.  Name             Client Host                Session Start        Idle  </HP3>\n",
"ge:<TITLE>Server Status<P><XMP>\
<HP1>Server:</HP1> %s\n\n\
<HP1>Lokale Zeit:</HP1> %s  <HP1>Startzeit:</HP1> %s (%d Tage,%02d:%02d:%02d)\n\n\
<HP1>Auslastung:</HP1> %6.2f (1')  %6.2f (15')  %6.2f (60')  %6.2f (seit Start)\n\n\n\
<HP1>Benutzer derzeit:</HP1>\n\n\
<HP3>  No.  Name             von Rechner                Sitzungsbeginn     unttig </HP3>\n",
"fr:<TITLE>Status du Serveur<P><XMP>\
<HP1>Serveur:</HP1> %s\n\n\
<HP1>Temps Serveur:</HP1> %s  <HP1>Mise en route:</HP1> %s (%d jours, %02d:%02d:%02d)\n\n\
<HP1>Indice de performance:</HP1> %6.2f (1')  %6.2f (15')  %6.2f (60')  %6.2f (heure de mise en route)\n\n\n\
<HP1>Utilisateurs connects:</HP1>\n\n\
<HP3>  No.  Nom              Hte Client                Dbut              Inactif </HP3>\n",
"st:<TITLE>Server Status<P><XMP>\
<HP1>Maschin:</HP1> %s\n\n\
<HP1>Wia schpot:</HP1> %s  <HP1>Stoatzeit:</HP1> %s (%d Tog, %02d:%02d:%02d)\n\n\
<HP1>Tua ma wos:</HP1> %6.2f (1')  %6.2f (15')  %6.2f (60')  %6.2f (onfong)\n\n\n\
<HP1>Leitln de wos grod drin san:</HP1>\n\n\
<HP3>  No.  Wiara hat       vun wou                    Ongfongt hot a     tuat nix</HP3>\n");

