// language.h
//
// All language-specific user interface elements are defined here.
// Fatal error messages are in English and are not defined here.
//

#ifndef __language_h
#define __language_h

#include <apps/langutl.h>

// Commands -- be careful: have to match entries in commands[][]
#define COMM_HELP        0
#define COMM_QUIT        1
#define COMM_EXIT        2
#define COMM_ENGLISH     3
#define COMM_GERMAN      4
#define COMM_FRENCH      5
#define COMM_STYRIAN     6
#define COMM_INFO        7
#define COMM_LINKS       8
#define COMM_REFS        9
#define COMM_BROWSE     10
#define COMM_OUTPUT     11
#define COMM_FINDOBJ    12
#define COMM_FINDSIM    13
#define COMM_KEYQUERY   14
#define COMM_FULLTEXT   15
#define COMM_CHILDREN   16
#define COMM_PARENTS    17
#define COMM_HOME       18
#define COMM_HISTORY    19
#define COMM_UNDO       20
#define COMM_REDO       21
#define COMM_CONT       22
#define COMM_SU         23
#define COMM_INSDOC     24
#define COMM_ERASE      25
#define COMM_MOVETO     26
#define COMM_COPYTO     27
#define COMM_UNLINK     28
#define COMM_DUP        29
#define COMM_MAILNATIVE 30
#define COMM_MAILASCII  31
#define COMM_MAILPS     32
#define COMM_MAILRTF    33
#define COMM_OPTSORT    34
#define COMM_OPTFTEXT   35
#define COMM_ACTIVATE   36
#define COMM_DEACTIVATE 37
#define COMM_SHOWACTIVE 38
#define COMM_STATUS     39
#define COMM_EDITTEXT   40
#define COMM_NEWTEXT    41
#define COMM_ANNOTATE   42
#define COMM_LINK       43
#define COMM_REDRAW     44
#define COMM_MODIFY     45
#define COMM_ADDATTR    46
#define COMM_CHGPASS    47
#define COMM_GOTO       48
#define COMM_SHOWANNO   49

#define COMM_FOLLINK    50

#define COMM_INSCOLL    51
#define COMM_INSCLUST   52
#define COMM_INSIMAGE   53
#define COMM_INSMOVIE   54
#define COMM_INSSOUND   55
#define COMM_INSSCENE   56
#define COMM_INSPS      57
#define COMM_INSREMOTE  58
#define COMM_INSGENERIC 59

#define COMM_SENDMSG    60
#define COMM_MAKELINK   61
#define COMM_INLINE     62
#define COMM_SPANISH    63
#define COMM_ITALIAN    64

#define NUMCOMMANDS  (COMM_ITALIAN+1)

/* not really language-specific, but used in a number of places: */
#define DO_MOUSECLICK   '\6'
#define DO_MOUSEDCLICK  '\5'
#define DO_GUICMD       '\3'
#define DO_CONTINUE     '\2'
#define DO_CLEAR        '\1'

#define ENGLISH 0
#define GERMAN  1
#define FRENCH  2
#define STYRIAN 3
#define SPANISH 4
#define ITALIAN 5

extern LangMsg help_comm;
extern boolean invalid[NUMCOMMANDS];
extern LangMsg commands[NUMCOMMANDS];

extern LangMsg Copyrightstr;
extern LangMsg Commandstr;
extern LangMsg Pagestr;
extern LangMsg Movestr;
extern LangMsg MvPgstr;
extern LangMsg Followstr;
extern LangMsg Keywordstr;
extern LangMsg Fulltextstr;
extern LangMsg ISearchstr;
extern LangMsg UserIDstr;
extern LangMsg Passwordstr;
extern LangMsg OldPassstr;
extern LangMsg NewPassstr;
extern LangMsg Againstr;
extern LangMsg Gotostr;
extern LangMsg Outputstr;
extern LangMsg Mailstr;
extern LangMsg Savestr;
extern LangMsg Authorstr;
extern LangMsg Datestr;
extern LangMsg SortOrdstr;
extern LangMsg OptFtextstr;
extern LangMsg Resultstr;
extern LangMsg Completestr;
extern LangMsg Historystr;
extern LangMsg Activestr;
extern LangMsg Childrenstr;
extern LangMsg Parentsstr;
extern LangMsg Similarstr;
extern LangMsg Modifystr;
extern LangMsg Addattrstr;
extern LangMsg Connectstr;
extern LangMsg Textstr;
extern LangMsg Bytesstr;
extern LangMsg CheckLinkstr;
extern LangMsg Formatstr;
extern LangMsg Sortstr;
extern LangMsg Linkstr;
extern LangMsg Refstr;
extern LangMsg ShowAnnostr;
extern LangMsg Returnstr;
extern LangMsg Abortstr;
extern LangMsg Waitstr;
extern LangMsg Quitstr;
extern LangMsg Yesstr;
extern LangMsg Nostr;
extern LangMsg Nofindstr;
extern LangMsg Overflowstr;
extern LangMsg Notimplstr;
extern LangMsg Invalidstr;
extern LangMsg Noundostr;
extern LangMsg Noredostr;
extern LangMsg Existsstr;
extern LangMsg Changestr;
extern LangMsg NotIdentstr;
extern LangMsg Noactivestr;
extern LangMsg WrongPasswordstr;
extern LangMsg CloseLinkLeftline;
extern LangMsg CloseLinkRightline;
extern LangMsg Annostr;
extern LangMsg MMwaitstr;
extern LangMsg MMnoavailstr;
extern LangMsg DirStatusline;
extern LangMsg TextStatusline;

extern LangMsg ServerStatStr;


#endif
