// This may look like C code, but it is really -*- C++ -*-

// **********************************************************
// File viewerlist.h
// ----------------------------------------------------------
// Created: T. Dietinger
// 
// The viewerlist is used by the session manager
// to keep track of its opened viewers.
//
// **********************************************************

#ifndef viewerlist_h
#define viewerlist_h

#include "hgobject.h"
#include <utils/list.h>

class CSocket;
struct CMDIObjectInfo;

// **********************************************************
// class ViewerNode
// ----------------------------------------------------------
// **********************************************************
class ViewerNode : public DLListNode 
{
public:
    ViewerNode (Document* o);
    virtual ~ViewerNode();          // is called by unref

    boolean viewDocument(Document* o);
    CMDIObjectInfo* getMDIObjInfo()  { return viewerInfo_; }

public:
    ObjectPtr docPtr_;
    RString viewerApp_;
    RString tempName_;

private:
    LPEXECAPPINFO pId_;             // process ID of external viewer application
    CMDIObjectInfo* viewerInfo_;    // internal viewer information 
};

// **********************************************************
// class ViewerList
// ----------------------------------------------------------
// **********************************************************

DLListdeclare(ViewerList,ViewerNode)

extern Object hgviewerrc;
extern boolean readConfigFile();
extern RString documentViewer(const Document*);
extern void runCommand(const RString& cmd, const Document*);

extern BOOL getCompleteFileName( RString& fileName, boolean& forceLoad);
extern RString getTempNameExt( const char *testFileBuf, int bufLen );
extern RString getTempName(Document* o);

#endif

