#ifndef HG_SOCKET_H
#define HG_SOCKET_H


#include <stdafx.h>
#include <pcutil/bsdstuff.h>
#include <utils/list.h>

#ifdef LOCAL_DB_20
struct S_result;
typedef S_result* SOCKET;
#define INVALID_SOCKET  (SOCKET)(~0)
#define SOCKET_ERROR            (-1)
#endif

// structure for storing used socket file descriptors
class CSockIdNode : public DLListNode
{
public:
    CSockIdNode(SOCKET sId);

    SOCKET getSockId() { return sId_; }

protected:

    SOCKET sId_;
};


DLListdeclare(CTmpSockIdList, CSockIdNode)

class CSockIdList : public CTmpSockIdList
{
public:
    void addTail(SOCKET sId);
    void remove(SOCKET sId);
    void removeAll();
};


class CSocket       // class library for STREAM sockets
{            
public:
    CSocket();
    CSocket(SOCKET sId);
    CSocket(const char* host, int port);
    ~CSocket();
    void Open();
    int Connect(const struct sockaddr* name, int nameLen);
    int Connect(const char* host, int port);
    int Close();            
    int Read(void far* buf, int len);
    int Write(const void far* buf, int len);
    void dontLinger();              // gracefull close
    void linger(int timeout = 0);   // prevent hang at closesocket (if we couldn't finish a Read or Write)
    BOOL sockIsValid() { return sId_==INVALID_SOCKET ? FALSE : TRUE; }
    
    SOCKET getSockId() { return sId_; }

    static CSockIdList usedSockets_;

protected:
    void setSockId(SOCKET sId) { sId_ = sId; }
    
private:
    void initLib();
    
    static long winsockRef_;        // reference counter for # of CSocket's
    SOCKET sId_;
//    CString host_;
    int port_;
#ifdef LOCAL_DB_20
	long lSize, lRead;
	static long lRefNo;
	int nType;
#endif
};





#endif
